This directory contains examples for OPC client and subscriber development in Python. The examples cover OPC Data Access 
(OPC DA), OPC Alarms&Events (OPC A&E), OPC XML, and OPC Unified Architecture (OPC UA) specifications, including OPC UA 
PubSub. They are supported on Microsoft Windows and Linux.

The examples work with our sample servers and publishers. Most of them reside on the Web; OPC "Classic" servers for Windows
are installed using the [OPC Studio Setup program](https://www.opclabs.com/products/quickopc/downloads).

The QuickOPC package is needed. Install it using "pip install opclabs_quickopc".

Useful links:
* [OPC client and subscriber examples in the documentation](https://opclabs.doc-that.com/files/onlinedocs/OPCLabs-OpcStudio/2024.1/User%27s%20Guide%20and%20Reference-OPC%20Studio/webframe.html#Examples%20in%20the%20Documentation%20(List%29.html).
* [OPC client and subscriber examples in Python on GitHub](https://github.com/OPCLabs/Examples-QuickOPC-Python).
* [OPC Studio Setup program](https://www.opclabs.com/products/quickopc/downloads)
* [Getting started with OPC in Python](https://opclabs.doc-that.com/files/onlinedocs/OPCLabs-OpcStudio/2024.1/User%27s%20Guide%20and%20Reference-OPC%20Studio/webframe.html#Getting%20Started%20in%20Python.html).
* [QuickOPC Python package on pypi.org](https://pypi.org/project/opclabs-quickopc/).
* [Python-related articles in OPC Labs Knowledge Base](https://kb.opclabs.com/Category:Python).
* [Introduction to OPC and Python on our Web page](https://www.opclabs.com/products/quickopc/languages-and-tools/python).
* [Programming OPC in Python](https://opclabs.doc-that.com/files/onlinedocs/OPCLabs-OpcStudio/2024.1/User%27s%20Guide%20and%20Reference-OPC%20Studio/webframe.html#Programming%20in%20Python.html).

Need help, or missing some example? Ask us for it on our [Online Forums](https://www.opclabs.com/forum/index)!
You do not have to own a commercial license in order to use Online Forums, 
and we reply to every post.
